import java.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.ArrayList;

public class Ksistof {

    public static void main(String[] args) {

         JFrame frame = new JFrame();
       frame.setSize(600, 400);
       frame.setTitle("Simulation Demo");
       frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

       Container contentPane = frame.getContentPane();

       TestSimulationPanel panel = new TestSimulationPanel();

       panel.setSimulationObject(new SimulationObjectTest());
         contentPane.add(panel, BorderLayout.CENTER);

       panel.StartWindow(frame);

    }

}


class TestSimulationPanel extends JPanel implements MouseListener
{
   SimulationObjectTest figure;
   public void setSimulationObject(SimulationObjectTest simulationObject)
   {
      this.figure = simulationObject;
      figure.initArrayList();
      this.addMouseListener(this);

   }

    public void mouseClicked( MouseEvent e ) {  // called during motion when no buttons are down
      int mx = e.getX();
      int my = e.getY();
      figure.checkDots(mx,my);

      repaint();

   }

    public void mouseExited( MouseEvent e ) {
      // called when the pointer leaves the applet's rectangular area
   }
    public void mousePressed( MouseEvent e ) {  // called after a button is pressed down

   }
   public void mouseReleased( MouseEvent e ) {  // called after a button is released

   }
   public void mouseMoved( MouseEvent e ) {  // called during motion when no buttons are down

   }
   public void mouseDragged( MouseEvent e ) {  // called during motion with buttons down

   }
    public void mouseEntered( MouseEvent e ) {
      // called when the pointer enters the applet's rectangular area
   }


 public final void run()
    {

            if (updateModel())
            {
               repaint(); // Canvas
            }

    }



    public void StartWindow(JFrame our){

    // Show frame
    this.start();
    our.show();


    }
    public void start(){

    }

   public TestSimulationPanel(){super();}

    /** Overriden.
        Update status of simulation model
      */
    protected boolean updateModel()
    {
       return this.figure.update();
    }

    /** Overriden
        Paint the panel acording to model state
      */

     protected void paintComponent(Graphics g)
    {
       super.paintComponent(g);
       paintModel(g);
    }





    protected void paintModel(Graphics g)
    {
       int sizeX  = this.getWidth();
       int sizeY  = this.getHeight();

       // ! Note accessing data is not safe here !
       if (null != this.figure)
       {
           figure.paint(g, sizeX, sizeY);
       }
    }

    // Other methods
}

class SimulationObjectTest
{
public ArrayList<Point> Points = new ArrayList<Point>();
int[] arrX = new int[]{100,100,220,220,300,380,380,500,500,380,300,220};
int[] arrY = new int[]{60 ,340,340,200,280,200,340,340,60 ,60 ,160,60 };

public void initArrayList()
 {
    for(int i = 0;i<=4;i++)
    {
        Points.add(new Point(arrX[i],arrY[i]));

    }

 }


   public boolean update()
   {

       return true; // true if object is to be repainted
   }

   /** Paint self */
     public void checkDots(int x, int y){
        int d;
        d = 0;
        Point t = new Point(x,y);
        double distance = (new Point(arrX[0],arrY[0])).distance(t);

        System.out.println(arrX.length);
        for(int i = 0; i < arrX.length; i++) {
    System.out.println(arrX[i]+" "+arrY[i]);
    System.out.println(distance);
            if(distance > (new Point(arrX[i],arrY[i])).distance(t)) {
                d = i;
                distance =(new Point(arrX[i],arrY[i])).distance(t);
            }



        }
            arrX[d] = x;
        arrY[d] = y;


    }

   protected void paint(Graphics g, int sizeX, int sizeY)
   {
    int p = 0;
    g.setColor(new Color(249));
    g.drawPolygon(arrX,arrY, 12 );


   }
}